﻿/* ETBFmIdent.jsx ====== UTF-8 ========================================================================
Documents     See ETB documentation FM 12/13 and FM 14/15 etc.
Comment       • To be installed by ETB installation into Startup folder
              • Installation script must modify the menu files by adding
                <Order !MakerMainMenu.!FMidMain     <Before !MakerMainMenu.FileMenu>>
              • Installation script must fill maker.ini with the required data.
                Some of the required data can not be obtained by ESTK (e.g. build number)
Reference     Traduction française avec l'aide de https://www.deepl.com/translator par Klaus Daube
Copyleft      2019 Klaus Daube, Zürich, Switzerland, klaus@daube.ch
History       2019-09-16 starting development
         v1.0 2019-09-23 Inserted into ETB 15 en, de
*/ ; // ===========================================================================================
#target framemaker
Fin_oInfo = {};
Fin_FMident ();

function Fin_FMident (){
var bkFMidMenu, docFMidMenu, menuLocation, oMenus = {}, oCmd = {}, sVmajor;

  Fin_GetInfo ();
  sVmajor = Fin_oInfo.FMversion.substring(0, 2);
  oMenus.MenuMain = sVmajor;                      // top menu can not execute a command
  oMenus.MenuInfo = "Information";
// --- Menu and Command definition for documents 
  oCmd.MenuInfo   = DefineCommand(1,"FMid",  oMenus.MenuInfo, "");
  menuLocation = app.GetNamedMenu("!MakerMainMenu"); 
  docFMidMenu  = menuLocation.DefineAndAddMenu("!FMidDoc", oMenus.MenuMain); // ! required for top menu
  docFMidMenu.AddCommandToMenu (oCmd.MenuInfo);
// --- Menu and Command definition for books 
  oCmd.bkMenuInfo = DefineCommand(1,"FMid",  oMenus.MenuInfo, "");;
  menuLocation = app.GetNamedMenu("!BookMainMenu"); 
  bkFMidMenu   = menuLocation.DefineAndAddMenu("!FMidBook", oMenus.MenuMain); // ! required for top menu
  bkFMidMenu.AddCommandToMenu (oCmd.bkMenuInfo);

  UpdateMenus();
} // --- end Fin_FMident

function Command(cmd) { // ========================================================================
	switch(cmd)  {	                                // Respond to menu command.
		case 1: 
      Fin_PutInfo ();
      break;
    }
} // --- end Command

function Fin_GetInfo () { // === get the information from maker.ini ===============================
                                        
  Fin_oInfo.InfoDate  = Fin_GetIniValue ("..\\maker.ini", "InfoDate");       // 2019-09-23 14:36
  Fin_oInfo.FMhome    = Fin_GetIniValue ("..\\maker.ini", "InfoFMhome");     // H:\Adobe\FrameMaker.15en\Adobe FrameMaker 2019
  Fin_oInfo.FMversion = Fin_GetIniValue ("..\\maker.ini", "InfoFMfull");     // 15.0.4.751
  Fin_oInfo.FMedition = Fin_GetIniValue ("..\\maker.ini", "InfoFMedition");  // 2019
  Fin_oInfo.FMbitty   = Fin_GetIniValue ("..\\maker.ini", "InfoFMbitty");    // 64
  Fin_oInfo.UIlanguage= Fin_GetIniValue ("..\\maker.ini", "InfoUIlanguage"); // en
  Fin_oInfo.OSversion = Fin_GetIniValue ("..\\maker.ini", "InfoOSversion");  // Win7 64-bit
} // --- end Fin_GetInfo

function Fin_PutInfo () { // === get the information from maker.ini ===============================
var sText = "", sText1, sText2; 

  if (Fin_oInfo.UIlanguage == "de") {
    sText1= "Information über diese FM Installation per " + Fin_oInfo.InfoDate + "\n";
    sText = sText + "\nVolle FM Version: \t" + Fin_oInfo.FMversion;
    sText = sText + "\nVermarktet als: \t"       + Fin_oInfo.FMedition;
    sText = sText + "\nUI Sprache:\t"      + Fin_oInfo.UIlanguage;
    sText = sText + "\nInstallationspfad:\t"   + Fin_oInfo.FMhome
    sText = sText + "\nFrameMaker.exe ist ein "   + Fin_oInfo.FMbitty + "-bit Programm";
    sText = sText + "\nBetriebssystem: \t"   + Fin_oInfo.OSversion;
    sText2= "\n\nIn die Zwischeablage kopieren mit Kontextmenü 'Alles auswählen'; dann mit Strg+c kopieren.";
  } else if (Fin_oInfo.UIlanguage == "fr") {
    sText1= "Informations sur cette installation FM à partir de " + Fin_oInfo.InfoDate + "\n";
    sText = sText + "\nVersion complète de FM :\t" + Fin_oInfo.FMversion;
    sText = sText + "\nCommercialisé sous : \t"       + Fin_oInfo.FMedition;
    sText = sText + "\nLangue de l'interface utilisateur: "      + Fin_oInfo.UIlanguage;
    sText = sText + "\nChemin d'installation :\t"   + Fin_oInfo.FMhome
    sText = sText + "\nFrameMaker.exe est une "   + Fin_oInfo.FMbitty + "-bit application";
    sText = sText + "\nSystème d'exploitation : \t"   + Fin_oInfo.OSversion;
    sText2= "\n\nPour copier dans le presse-papiers, utilisez le menu contextuel 'Tout sélectionner' ; puis CTRL+c pour copier.";
  } else {                                        // default is English
    sText1= "Information about this FM installation as of " + Fin_oInfo.InfoDate + "\n";
    sText = sText + "\nFull version of FM: \t" + Fin_oInfo.FMversion;
    sText = sText + "\nMarketed as : \t"       + Fin_oInfo.FMedition;
    sText = sText + "\nLanguage of UI:\t"      + Fin_oInfo.UIlanguage;
    sText = sText + "\nInstallation path:\t"   + Fin_oInfo.FMhome
    sText = sText + "\nFrameMaker.exe is a "   + Fin_oInfo.FMbitty + "-bit application";
    sText = sText + "\nOperating system: \t"   + Fin_oInfo.OSversion;
    sText2= "\n\nTo copy to the clipboard use context menu 'Select all'; then CTRL+c to copy.";
  }
 Fin_Message ( "FMident — Information", sText1 + sText + sText2);
} // --- end Fin_PutInfo

function Fin_GetIniValue (sIniFile, sValueName) { // === Read an ini item into a variable =========
// Arguments  sIniFile   ini file name (e.g. "
//            sValueName is that used in the ini-file (e.g. "FMhome")
// Returns    Value from the ini file (string)
// Attention  Windows ini files are still only CP 1252, whareas maker.ini can be UTF-8 also
// Comment    Empty lines, comments and section names are skipped
// Used in   FMbiblio, Fin_FMident
  var settingsFile, sFoundValue, thisLine, match, notFound = true; 
    regex = {
    section: /^\s*\[\s*([^\]]*)\s*\]\s*$/,
    param: /^\s*([\w\.\-\_]+)\s*=\s*(.*?)\s*$/,
    comment: /^\s*;.*$/ } ;

  settingsFile = new File($.fileName.replace (/[^\\\/]+$/i , sIniFile)); // method Ric Quatro
  settingsFile.open("r");

  while(!settingsFile.eof) { 
    thisLine = settingsFile.readln();                  
    if (thisLine === null || thisLine === "") {   // skip blank lines
      continue;
    }
    if (regex.comment.test(thisLine))  {          // skip comment lines
      continue;
    } 
    if (regex.section.test(thisLine))  {          // ignore section lines
      continue;
    }

    match = thisLine.match(regex.param);          // ignore undefined contents

    if (match[1] == sValueName) {
      sFoundValue = match[2];
      notFound = false;
      break;                                      // no need to continue while loop
    }
  }
  if (notFound) {
    alert ("Program error in Fin_GetIniValue: \n\nsValueName " + sValueName + "\nnot found in sIniFile " + sIniFile);
    stop;
  }
  settingsFile.close();
  return sFoundValue;
} // --- end Fin_GetIniValue

function Fin_Message (winTitle, msgTxt) { // === Create message dialgogue =========================
  var xLoc = $.screens[0].right / 2;
  var yLoc = $.screens[0].bottom / 3;
  var win = new Window ("dialog", winTitle) ;

  win.location = [xLoc, yLoc]; 
  win.orientation = "column";  
  win.g1 = win.add ('group {orientation: "row"}');
//win.g1.img = win.g1.add("image", undefined, "SystemInfoIcon");  // can not be found
  win.g1.info = win.g1.add("staticText", undefined, msgTxt, {multiline: true, scrolling: true});  
  win.g1.info.graphics.font = ScriptUI.newFont ("", "", 14);
  win.g1.info.preferredSize.width  = 560
  win.g1.info.preferredSize.height = 200;
  win.g2 = win.add ('group {orientation: "row"}');
  win.g2.btnOK = win.add ("button", undefined, "OK");
// Windows is created only if a button exists!
  win.g2.btnOK.onClick                = function () {
    win.close();                                  // close also with X button action
  };

  win.show();
} // --- end Fin_Message
